﻿using Prism.Ioc;
using Borepin.PageModel;
using Borepin.Page;
using Xamarin.Forms;
using Borepin.Dialog;
using Borepin.DialogModel;
using Borepin.Service.Connections;
using Borepin.Service.BFFH;
using Borepin.Service.Credentials;
using System.Collections.Generic;
using Borepin.Model;
using Prism;

namespace Borepin
{
    public partial class App
    {
        public App(IPlatformInitializer platformInitializer) : base(platformInitializer)
        {
            
        }

        protected override async void OnInitialized()
        {
            InitializeComponent();

            Prism.Navigation.INavigationResult result = await NavigationService.NavigateAsync("/MainPage/NavigationPage/TestPage");
            if (!result.Success)
            {
                System.Diagnostics.Debugger.Break();
            }
        }

        protected override void RegisterTypes(IContainerRegistry containerRegistry)
        {
            // Register Navigation
            containerRegistry.RegisterForNavigation<NavigationPage>();
            containerRegistry.RegisterForNavigation<MainPage, MainPagePageModel>();
            containerRegistry.RegisterForNavigation<MachinePage, MachinePageModel>();
            containerRegistry.RegisterForNavigation<SettingsPage>();
            containerRegistry.RegisterForNavigation<MachineListPage, MachineListPageModel>();
            containerRegistry.RegisterForNavigation<LoginPasswordPage, LoginPasswordPageModel>();
            containerRegistry.RegisterForNavigation<HostSelectPage, HostSelectPageModel>();
            containerRegistry.RegisterForNavigation<LoginChoosePage, LoginChoosePageModel>();
            containerRegistry.RegisterForNavigation<ServerListPage, ServerListPageModel>();
            containerRegistry.RegisterForNavigation<ServerPage, ServerPageModel>();
            containerRegistry.RegisterForNavigation<ListPage, ListPageModel>();
            containerRegistry.RegisterForNavigation<TestPage, TestPageModel>();

            // Register Dialog
            containerRegistry.RegisterDialog<ConfirmDialog, ConfirmDialogModel>();

            // Register Service
            containerRegistry.Register<IConnectionService, ConnectionService>();
            containerRegistry.Register<ICredentialService, CredentialService>();
            containerRegistry.RegisterSingleton<IBFFHService, BFFHService>();
        }
    }
}
