﻿using Borepin.Base;
using Prism.Navigation;
using System.Threading.Tasks;

namespace Borepin.PageModel
{
    class TestPageModel : PageModelBase
    {
        #region Contructors
        public TestPageModel(INavigationService navigationService) : base(navigationService)
        {

        }
        #endregion

        #region Data
        public override async Task<bool> LoadData()
        {
            await Task.Delay(3000);

            IsBusy = false;
            return await Task.FromResult(true);
        }
        #endregion

        #region INavigationService
        public override void OnNavigatedFrom(INavigationParameters parameters)
        {

        }

        public override void OnNavigatedTo(INavigationParameters parameters)
        {
            IsBusy = true;
            Task.Run(LoadData);
        }
        #endregion
    }
}
